 #define N 512

/* .h file which sets up entry and exit macros */
#include <asm_sprt.h>
#include <def2181.h>

.extern	_Buffer1;
.extern _Buffer0;
.extern _db_tgl;

.extern _Bit_Reversal_On;
.extern _DoFFT;

.section /pm program;

.global SPORT0_RX_Interrupt;
SPORT0_RX_Interrupt:

	/* First, enable secondary register set so we don't corrupt anything back in C-world */
	ena SEC_REG;

	/* 	Second, did we enter this interrupt because we completed an autobuffer wrap,
		or did we enter it because we disabled autobuffering and a new sample came in?
	*/


	ax0 = dm(_Bit_Reversal_On);
	ar = pass ax0;
	if EQ jump	Autobuffering_Interrupt;
Non_Autobuffering_Interrupt:

	/* Disable bitreversal so we can store the data correctly */
	dis	BIT_REV;


	ax0	= rx0;
	ay1 = i2;
	dm(i2,m1) = ax0;
	ax1 = i2;
	
	/* 	Check to see if the circular buffer pointer wrapped around, if so, this would have generated an autobuffering
		interrupt so service it as such */
	ar = ax1 - ay1;
	if LT jump Autobuffering_Interrupt;

	/* 	When an interrupt comes in, the status registers are pushed onto the status stack.  When we return from an 
		interrupt, these values are automatically restored so although we enabeld secondary registers and
		disabled bit-reversal, we don't have to set them back as this will automatically happen during an RTI instruction! */
	rti;



Autobuffering_Interrupt:
	ax0 = 1;
	dm(_DoFFT) = ax0;

	ax0 = dm(_db_tgl);
	ar = pass ax0;
	IF NE jump Buffer0_Use;

Buffer1_Use:
	i2 = _Buffer1;
	ar = NOT ar;
	dm(_db_tgl) = ar;
	rti;

Buffer0_Use:
	i2 = _Buffer0;
	ar = NOT ar;
	dm(_db_tgl) = ar;
	rti;


